#include <bits/stdc++.h>

/*
#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops","omit-frame-poller","inline")
#pragma GCC terget("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tume=native")
#endif
 */

template<typename T>
int sz(T &a) {
    return (int) a.size();
}

using namespace std;
using ll = long long;
// #define int long long

const ll N = 2e5 + 1;
ll h[N];
ll c[N];
ll n;

pair<ll, ll> tree[N * 4];

void build(ll v, ll tl, ll tr) {
    if (tl == tr) {
        tree[v] = {h[tl], tl};
        return;
    }
    ll tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

pair<ll, ll> get(ll v, ll tl, ll tr, ll l, ll r) {
    if (tl > r || tr < l) {
        return {0, 0};
    }
    if (tl >= l && tr <= r) {
        return tree[v];
    }
    ll tm = (tl + tr) / 2;
    return max(get(v * 2, tl, tm, l, r),
               get(v * 2 + 1, tm + 1, tr, l, r));
}

ll rec(ll l, ll r) {
    auto mx = get(1, 1, n, l, r);
    ll pos = mx.second;
    if (pos == l || pos == r) {
        return c[pos];
    }
    return min(rec(l, pos - 1), rec(pos + 1, r)) + c[pos];
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> h[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> c[i];
    }
    build(1, 1, n);
    cout << rec(1, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
