#include <bits/stdc++.h>

/*
#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops","omit-frame-poller","inline")
#pragma GCC terget("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,fma,tume=native")
#endif
 */

template<typename T>
int sz(T &a) {
    return (int) a.size();
}

using namespace std;
using ll = long long;
#define int long long

long double pow(long double m, ll k) {
    if (k == 0) {
        return 1;
    }
    if (k == 1) {
        return m;
    }
    if (k % 2 == 0) {
        return pow(m * m, k / 2);
    } else {
        return pow(m * m, k / 2) * m;
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    long double r;
    cin >> r;
    map<ll, long double> q;
    q[0] = 0;
    ll ld = 0;
    long double sum = 0;
    vector<pair<ll, ll>> f(n);
    for (int i = 0; i < n; ++i) {
        cin >> f[i].first >> f[i].second;
    }
    std::sort(f.begin(), f.end());
    for (int i = 0; i < n; ++i) {
        ll d = f[i].first;
        ll w = f[i].second;
        sum *= pow(1 - r, d - ld);
        sum += w * r;
        q[d] = sum;
        ld = d;
    }
    cout << setprecision(10);
    for (int i = 0; i < m; ++i) {
        ll p;
        cin >> p;
        auto u = *(--q.upper_bound(p));
        cout << (u.second * pow(1 - r, p - u.first)) << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
