﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <fstream>

using namespace std;
typedef long long ll;
vector<int>posl;
int log2(int a) {
    int ans = 0;
    while (a != 1) {
        a /= 2;
        ans++;
    }
    return ans;
}

int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef _DEBUG
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#endif


    int n; cin >> n;
    int k = log2(n + 1);
    map<int, int> mp;
    vector<int> uni;

    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        uni.push_back(x);
        mp[x] = mp[x] + 1;
    }
    set<int> st;
    for (auto i : uni) {
        st.insert(i);
    }
    uni.clear();
    for (auto i : st) {
        uni.push_back(i);
    }

    if ((n + 1) / 2 != uni.size()) {
        cout << -1;
        return 0;
    }


    posl.push_back(1);
    while (posl.size() != (n + 1) / 2)
    {
        int k = posl.size();
        for (int i = 0; i < k; i++)
        {
            posl.push_back(posl[i]);
        }
        posl[0] += 1;
    }
    int now = 0;
    for (auto i : mp) {
        if (posl[now] != i.second) {
            cout << -1;
            return 0;
        }
        now++;
    }
    for (auto i : uni) {
        cout << i << " ";
    }

}