#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

const ll INF = 1e18, MAXN = 2e5;

random_device rd;
mt19937_64 rnd(rd());

vector<vector<char>> a(12, vector<char>(12, '.'));
vector<vector<bool>> used(12, vector<bool>(12));
int c = 0;
pair<int, int> l = {INF, INF}, r = {-INF, -INF};

void dfs(int x, int y) {
    used[x][y] = true;
    if (x > r.first) {
        r = {x, y};
    } else if (x == r.first && y < r.second) {
        r = {x, y};
    }
    if (x < l.first) {
        l = {x, y};
    } else if (x == l.first && y > l.second) {
        l = {x, y};
    }
    c++;
    if (a[x + 1][y] == '#' && !used[x + 1][y]) {
        dfs(x + 1, y);
    }
    if (a[x - 1][y] == '#' && !used[x - 1][y]) {
        dfs(x - 1, y);
    }
    if (a[x][y + 1] == '#' && !used[x][y + 1]) {
        dfs(x, y + 1);
    }
    if (a[x][y - 1] == '#' && !used[x][y - 1]) {
        dfs(x, y - 1);
    }
    if (a[x + 1][y + 1] == '#' || a[x + 1][y - 1] == '#' || a[x - 1][y + 1] == '#' || a[x - 1][y - 1] == '#') {
        c = -INF;
    }
}

void solve() {
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            cin >> a[i][j];
        }
    }
    map<int, int> cnt;
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            if (a[i][j] == '#' && !used[i][j]) {
                c = 0;
                l = {INF, INF}, r = {-INF, -INF};
                dfs(i, j);
                if (c < 0 || c > 4) {
                    cout << "NO";
                    return;
                }
                cnt[c]++;
                if (l.first != r.first && l.second != r.second) {
                    cout << "NO";
                    return;
                }
            }
        }
    }
    vector<bool> fl(5);
    for (auto [k, v] : cnt) {
        if (k == 4) {
            if (v != 1) {
                cout << "NO";
                return;
            }
            fl[4] = true;
        } else if (k == 3) {
            if (v != 2) {
                cout << "NO";
                return;
            }
            fl[3] = true;
        } else if (k == 2) {
            if (v != 3) {
                cout << "NO";
                return;
            }
            fl[2] = true;
        } else if (k == 1) {
            if (v != 4) {
                cout << "NO";
                return;
            }
            fl[1] = true;
        } else {
            cout << "NO";
            return;
        }
    }
    if (fl[1] && fl[2] && fl[3] && fl[4]) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
