#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int maxn = 1e5 + 10;
const ll inf = 1e15;

struct troyka{
    int a, b, c;
};

set<int> g[maxn + 1];
unordered_set<int> bad;


void add(int v, int to) {
    g[v].insert(to);
    g[to].insert(v);
    bad.insert(v);
    bad.insert(to);
}

void del(int v, int to) {
    g[to].erase(v);
    g[v].erase(to);
    if (g[v].size() == 0) {
        bad.erase(v);
    }
    if (g[to].size() == 0) {
        bad.erase(to);
    }
}


void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    int v, to;
    for (int i = 0; i < m; i++) {
        cin >> v >> to;
        g[v].insert(to);
        g[to].insert(v);
        bad.insert(v);
        bad.insert(to);
    }
    for (int i = 0; i < k; i++) {
        cin >> v >> to;
        if (g[to].find(v) != g[to].end()) {
            g[to].erase(v);
            g[v].erase(to);
            if (g[v].size() == 0) {
                bad.erase(v);
            }
            if (g[to].size() == 0) {
                bad.erase(to);
            }
        } else {
            g[v].insert(to);
            g[to].insert(v);
            bad.insert(v);
            bad.insert(to);
        }
    }
    for (int i = 1; i <= n; i++) {
        if (g[i].size()%2 != 0) {
            cout << "NO";
            return;
        }
    }
    int u;
    cout << "YES\n";
    vector<troyka> ans;
    while (bad.size() > 0) {
        v = *bad.begin();
        bad.erase(bad.begin());
        while (g[v].size() > 0) {
            to = *g[v].begin();
            g[v].erase(g[v].begin());
            u = *g[v].begin();
            g[v].erase(g[v].begin());
            ans.push_back({v, u, to});
            del(v, u);
            del(v, to);
            if (g[to].find(u) == g[to].end()) {
                add(u, to);
            } else {
                del(u, to);
            }
        }
    }
    cout << ans.size() << '\n';
    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i].a << " " << ans[i].b << " " << ans[i].c << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
