#include <bits/stdc++.h>

using namespace std;
#define int long long
const int N = 3e5;
set<int> g1[N], g2[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m1, m2;
    cin >> n >> m1 >> m2;
    for (int i = 0; i < m1; ++i) {
        int q, w;
        cin >> q >> w;
        --q;
        --w;
        g1[q].insert(w);
        g1[w].insert(q);
    }
    for (int i = 0; i < m2; ++i) {
        int q, w;
        cin >> q >> w;
        --q;
        --w;
        g2[q].insert(w);
        g2[w].insert(q);
    }
    for (int i = 0; i < n; ++i) {
        if ((int) (g1[i].size() - g2[i].size()) & 1) {
            cout << "NO";
            return 0;
        }
    }
    vector<tuple<int, int, int>> ans;
    for (int i = 0; i < n; ++i) {
        vector<int> v;
        for (auto it: g1[i]) {
            if (it > i && g2[i].find(it) == g2[i].end()) {
                v.emplace_back(it);
            }
        }
        for (auto it: g2[i]) {
            if (it > i && g1[i].find(it) == g1[i].end()) {
                v.emplace_back(it);
            }
        }
        for (int j = 0; j < (int) v.size(); j += 2) {
            int x = v[j], y = v[j + 1];
            ans.emplace_back(i, x, y);
            if (g1[x].find(y) == g1[x].end()) {
                g1[x].insert(y);
                g1[y].insert(x);
            } else {
                g1[x].erase(y);
                g1[y].erase(x);
            }
        }
    }
    cout << "YES\n"<<ans.size() << '\n';
    for (auto [q, w, e]: ans) {
        cout << q + 1 << ' ' << w + 1 << ' ' << e + 1 << '\n';
    }
    return 0;
}
