#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 + 10;
int p[N], pos[N + 1];

struct Node {
    Node *l, *r;
    int sum;

    Node() : l(nullptr), r(nullptr), sum(0) {};

    Node(Node *L, Node *R, int s) : l(L), r(R), sum(s) {};
};

vector<Node *> ver = {new Node()};

Node *update(Node *v, int l, int r, int pos) {
    if (l == r) {
        Node *nt = new Node(nullptr, nullptr, 1);
        return nt;
    }
    Node *L, *R;
    int mid = (l + r) / 2;
    if (pos <= mid)
        L = update(v->l, l, mid, pos), R = v->r;
    else
        L = v->l, R = update(v->r, mid + 1, r, pos);
    Node *nt = new Node(L, R, L->sum + R->sum);
    return nt;
}

int find(Node *v, int l, int r, int k) {
    if (l == r)
        return l;
    if (v->l->sum >= k)
        return find(v->l, l, (l + r) / 2, k);
    return find(v->r, (l + r) / 2 + 1, r, k - v->l->sum);
}

void build(Node *v, int l, int r) {
    if (l == r)
        return;
    v->l = new Node(), v->r = new Node();
    build(v->l, l, (l + r) / 2);
    build(v->r, (l + r) / 2 + 1, r);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, q, k;
    cin >> n >> q >> k;
    for (int i = 0; i < n; i++)
        cin >> p[i];
    for (int i = 0; i < n; i++)
        pos[p[i]] = i + 1;
    build(ver[0], 0, n);
    for (int i = 0; i < n; i++)
        ver.emplace_back(update(ver.back(), 0, n, p[i]));
    int l[q], r[q];
    for (int i = 0; i < q; i++)
        cin >> l[i] >> r[i];
    for (int i = q - 1; i >= 0; i--) {
        if (l[i] <= k && k <= r[i]) {
            int K = k - l[i] + 1;
            k = l[i] - 1 + pos[find(ver[r[i] - l[i] + 1], 0, n, K)];
        }
    }
    cout << k;
    return 0;
}
