#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//#pragma GCC optimize("Ofast,unroll-loops)
//#pragma GCC target("popcnt,avx2,fma")
using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
#define ll long long
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define pb push_back
#define int long long

struct tree {
    int sum;
    tree *l;
    tree *r;

    tree() {
        sum = 0;
        l = r = nullptr;
    }

    tree(int x) {
        sum = x;
        l = r = nullptr;
    }
};

int getsum(tree *t) {
    if (t == nullptr) {
        return 0;
    }
    return t->sum;
}

void update(tree *&t, int l, int r, int pos, int x) {
    if (l == r) {
        t->sum += x;
        return;
    }
    int m = (l + r) / 2;
    if (pos > m) {
        if (t->r == nullptr) {
            t->r = new tree();
        }
        update(t->r, m + 1, r, pos, x);
    } else {
        if (t->l == nullptr) {
            t->l = new tree();
        }
        update(t->l, l, m, pos, x);
    }
    t->sum = getsum(t->l) + getsum(t->r);
}

int find_ans(tree *&t, int l, int r, int x, int y) {
    if (t == nullptr) {
        return 0;
    }
    if (l >= x && r <= y) {
        return getsum(t);
    } else if (l > r || x > y || l > y || x > r) {
        return 0;
    }
    int m = (l + r) / 2;
    return find_ans(t->l, l, m, x, y) + find_ans(t->r, m + 1, r, x, y);
}

int find_k(tree *&t, int l, int r, int x) {
    if (getsum(t) < x) {
        return -1;
    }
    if (l == r) {
        return l;
    }
    int m = (l + r) / 2;
    if (getsum(t->l) < x) {
        return find_k(t->r, m + 1, r, x - getsum(t->l));
    }
    return find_k(t->l, l, m, x);
}

int p[(int) 1e5 + 3];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    tree *t = new tree();
    set<pair<int, int>> s;
    int l = -1, r = -1;
    int n, k;
    cin >> n >> k;
    int now = 1;
    int kol = 0;
    while (k--) {
        char type;
        cin >> type;
        if (type == '+') {
            auto it = s.begin();
            if (it != s.end()) {
                if (l - 2 >= n - r -1 && l - 2 >= -it->first) {
                    int sum = (l - 1 - 1) / 2 + (l - 1) % 2;
                    sum = -sum;
                    s.insert({sum, 1});
                    update(t, 0, n, 1, 1);
                    p[now] = 1;
                    cout << 1 << "\n";
                } else if (l - 2 < -it->first && -it->first >= n - r - 1) {
                    int l1 = it->second;
                    int g = find_ans(t, 0, n, 0, l1);
                    int r1 = find_k(t, 0, n, g + 1);
                    int ind = l1 + (r1 - l1) / 2;
                    update(t, 0, n, ind, 1);
                    s.erase(s.begin());
                    int sum1 = (ind - l1 - 1) / 2 + (ind - l1) % 2, sum2 = (r1 - ind - 1) / 2 + (r1 - ind) % 2;
                    sum1 = -sum1, sum2 = -sum2;
                    s.insert({sum1, l1});
                    s.insert({sum2, ind});
                    p[now] = ind;
                    cout << ind << "\n";
                } else {
                    int sum = (n - r - 1) / 2 + (n - r) % 2;
                    sum = -sum;
                    s.insert({sum, r});
                    update(t, 1, n, n, 1);
                    p[now] = n;
                    cout << n << "\n";
                }
            } else {
                if (kol == 0) {
                    update(t, 0, n, 1, 1);
                    p[now] = 1;
                    cout << 1 << "\n";
                } else {
                    if (l - 2 >= n - l - 1) {
                        int r1 = find_k(t, 0, n, 1);
                        update(t, 0, n, 1, 1);
                        int sum = (r1 - 1 - 1) / 2 + (r1 - 1) % 2;
                        sum = -sum;
                        s.insert({sum, 1});
                        p[now] = 1;
                        cout << 1 << "\n";
                    } else {
                        int l1 = find_k(t, 0, n, 1);
                        update(t, 0, n, n, 1);
                        int sum = (n - l1 - 1) / 2 + (n - l1) % 2;
                        sum = -sum;
                        s.insert({sum, l1});
                        p[now] = n;
                        cout << n << "\n";
                    }
                }
            }
            kol++;
            now++;
        } else {
            int ind;
            cin >> ind;
            ind = p[ind];
            update(t, 0, n, ind, -1);
            int sum = find_ans(t, 0, n, 1, ind - 1);
            int l1;
            if (sum != 0) {
                l1 = find_k(t, 0, n, sum);
            } else {
                l1 = -1;
            }
            int r1 = find_k(t, 0, n, sum + 1);
            if (l1 != -1 && r1 != -1) {
                int sum1 = (ind - l1 - 1) / 2 - (ind - l1) % 2, sum2 = (r1 - ind - 1) / 2 - (r1 - ind - 1) % 2;
                sum1 = -sum1;
                sum2 = -sum2;
                s.erase({sum1, l1});
                s.erase({sum2, ind});
                int sum3 = (r1 - l1 - 1) / 2 - (r1 - l1) % 2;
                sum3 = -sum3;
                s.insert({sum3, l1});
            } else if (l1 != -1) {
                int sum1 = (ind - l1 - 1) / 2 - (ind - l1) % 2;
                sum1 = -sum1;
                s.erase({sum1, l1});
            } else if (r1 != -1) {
                int sum2 = (r1 - ind - 1) / 2 - (r1 - ind) % 2;
                sum2 = -sum2;
                s.erase({sum2, ind});
            }
            kol--;
        }
        l = find_k(t, 0, n, 1);
        r = find_k(t, 0, n, max(kol, 1ll));
    }
    return 0;
}
