#include <bits/stdc++.h>
#define ll long long
#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define ld long double
#define pii pair <int, int>
using namespace std;

const ll MOD = 1e9 + 7, INF = 1e18, N = 1e5 + 5;

mt19937 rnd(4321);

vector <pii> ang = {{1, 1}, {-1, 1}, {-1, -1}, {1, -1}};

vector <pii> nig1 = {{1, 0}, {-1, 0}};
vector <pii> nig2 = {{0, 1}, {0, -1}};

vector <pii> nig = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

map <int, int> cnt;

void solve() {
    ll n = 10;
    vector <vector <char> > v(n + 4, vector <char> (n + 4, '.'));
    for (int i = 2; i < n + 2; i++) {
        for (int j = 2; j < n + 2; j++) {
            cin >> v[i][j];
        }
    }

    for (int i = 2; i < n + 2; i++) {
        for (int j = 2; j < n + 2; j++) {
            if (v[i][j] == '.') continue;
            for (auto [dx, dy] : ang) {
                if (v[i + dx][j + dy] == '#') {
                    cout << "NO";
                    return;
                }
            }
            for(auto [dx1, dy1] : nig1) {
                for (auto [dx2, dy2] : nig2) {
                    if (v[i + dx1][j + dy1] == '#' && v[i + dx2][j + dy2] == '#') {
                        cout << "NO";
                        return;
                    }
                }
            }
            int col = 1;
            for(auto [dx, dy] : nig) {
                int x = i + dx, y = j + dy;
                while (v[x][y] == '#') {
                    col++;
                    x += dx;
                    y += dy;
                }
            }
            if (col > 4) {
                cout << "NO";
                return;
            }
            cnt[col]++;
        }
    }
//    cout << cnt[1] << " " << cnt[2] / 2 << " " << cnt[3] / 3 << " " << cnt[4] / 4 << endl;
    if (cnt[1] != 4 || cnt[2] / 2 != 3 || cnt[3] / 3 != 2 || cnt[4] / 4 != 1) {
        cout << "NO";
    } else {
        cout << "YES";
    }

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}
