#define miska ris

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

using ll = long long;
using ld = long double;

void solve();

#define int long long

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
//    ios::sync_with_stdio(false);
//    cin.tie(0), cout.tie(0);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

double said(double a, int step) {
    if (step == 0) {
        return 1;
    }
    if (step == 1) {
        return a;
    }
    if (step % 2) {
        return a * said(a, step - 1);
    } else {
        double d = said(a, step / 2);
        return d * d;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    double r;
    cin >> r;
    map<int, int> d;
    d[0] = 0;
    vector<int> h;
    h.push_back(0);
    for (int i = 0; i < n; ++i) {
        int g, w;
        cin >> g >> w;
        d[g] = w;
        h.push_back(g);
    }
    sort(h.begin(), h.end());
    map<int, double> ans;
    int pr = 0;
    ans[0] = 0;
    for (auto i = ++d.begin(); i != d.end(); ++i) {
        int k = i->first, w = i->second;
        ans[k] = ans[pr] * said(1 - r, k - pr) + r * w;
        pr = k;
    }
    for (int i = 0; i < m; ++i) {
        int q;
        cin >> q;
        int lef = 0, rig = n + 1;
        while (rig - lef > 1) {
            int mid = (lef + rig) / 2;
            if (h[mid] <= q) {
                lef = mid;
            } else {
                rig = mid;
            }
        }
        int elem = h[lef];
        cout << fixed << setprecision(7) << ans[elem] * said(1 - r, q - elem) << ' ';
    }
}