#include <bits/stdc++.h>

#define ll long long

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx2,fma")
using namespace std;

void fastinout() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
}

double r, x;
long long d[100010], w[100010];
double ans[100010];

double bin_pow(long long b) {
    if (b == 0) {
        return 1;
    }
    x = bin_pow(b/2);
    if (b % 2 == 0) {
        return x*x;
    } else {
        return x*x*(1-r);
    }
}

signed main() {
    fastinout();
    int n, m, q,x,y;
    cin >> n >> m;
    cin >> r;
    vector<pair<double,double>>vec;
    cin >> x >> y;
    vec.push_back({x,y});
    for (int i = 1; i < n; i++) {
        cin >> x >> y;
        vec.push_back({x,y});
    }
    sort(vec.begin(),vec.end());
    for(int i=0;i<n;i++){
        d[i]=vec[i].first;
        w[i]=vec[i].second;
    }
    ans[0] = w[0]*r;
    for(int i=1;i<n;i++){
        ans[i] = ans[i-1] * bin_pow(d[i] - d[i-1]) + w[i]*r;
    }
    while(m--) {
        cin >> q;
        if (q < d[0]) {
            cout << 0 << '\n';
            continue;
        }
        int l1 = 0, r1 = n,m1;
        while (r1>l1+1) {
            m1=l1+(r1-l1)/2;
            if(d[m1]<=q){
                l1=m1;
            }else{
                r1=m1;
            }
        }
        cout.precision(20);
        cout << ans[l1]* bin_pow(q-d[l1]) << '\n';
    }
    return 0;
}
