#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define int long long 

const int n = 10, m = 10;

bool check(int i, int j) {
	return i >= 0 && i < 10 && j >= 0 && j < 10;
}

bool used[10][10];

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    vector<vector<char>> a(n, vector<char>(n));
    int kek = 0;
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < n; j++) {
    		cin >> a[i][j];
    		kek += a[i][j] == '#';
    	}
    }
    if (kek != 20) {
    	cout << "NO\n";
    	return 0;
    }
    vector<int> cnt(5);
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++) {
    		if (!used[i][j] && a[i][j] == '#') {
    			deque<pair<int, int>> q{{i, j}};
    			used[i][j] = 1;
    			set<int> stx, sty;
    			while (q.size() > 0) {
    				int f = q.front().first, s = q.front().second;
    				q.pop_front();
    				stx.insert(f);
    				sty.insert(s);
    				for (int i = -1; i <= 1; i++) {
    					for (int j = -1; j <= 1; j++) {
    						if (check(i + f, j + s) && !used[i + f][j + s] && a[i + f][j + s] == '#') {
    							used[i + f][j + s] = 1;
    							q.pb({i + f, j + s});
    						}
    					}
    				}
    			}
    			if (stx.size() > 1 && sty.size() > 1) {
    				cout << "NO\n";
    				return 0;
    			}
    			cnt[max((int)stx.size(), (int)sty.size())]++;
    		}
    	}
    }
    if (cnt[1] == 4 && cnt[2] == 3 && cnt[3] == 2 && cnt[4] == 1) {
    	cout << "YES\n";
    } else {
    	cout << "NO\n";
    }
    return 0;
}
