#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define F first
#define S second
#define endl '\n'
#define rbtree tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

// s.find_by_order(k) k - й по величине
// s.order_of_key(x) сколько меньше x

using namespace __gnu_pbds;

using namespace std;


map<int, pair<int, int>> kek;
vector<int> p, s;
vector<vector<int>> v;

int leader(int v){
    if(p[v] == v){
        return v;
    }
    return p[v] = leader(p[v]);
}

void unite(int a, int b){
    a = leader(a), b = leader(b);
    if(a == b){
        return;
    }
    if(s[b] > s[a]){
        swap(a, b);
    }
    s[a] += s[b];
    p[b] = a;
    for(int i = 0; i < v[b].size(); i++){
        v[a].push_back(v[b][i]);
    }
    v[b].clear();
}

void init(){
    p.resize(100);
    s.resize(100);
    v.resize(100);
    for(int i = 0; i < 10; i++){
        for(int j = 0; j < 10; j++){
            p[i * 10 + j] = i * 10 + j;
            s[i * 10 + j] = 1;
            v[i * 10 + j].push_back(i * 10 + j);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    char a[10][10];
    for(int i = 0; i < 10; i++){
        for(int j = 0; j < 10; j++){
            cin >> a[i][j];
            kek[i * 10 + j] = {i, j};
        }
    }
    init();
    for(int i = 0; i < 10; i++){
        for(int j = 0; j < 10; j++){
            if(a[i][j] == '#') {
                if (i > 0 && j > 0) {
                    if(a[i - 1][j - 1] == '#'){
                        cout << "NO";
                        return 0;
                    }
                }
                if(i < 9 && j < 9){
                    if(a[i + 1][j + 1] == '#'){
                        cout << "NO";
                        return 0;
                    }
                }
                if(i < 9 && j > 0){
                    if(a[i + 1][j - 1] == '#'){
                        cout << "NO";
                        return 0;
                    }
                }
                if(i > 0 && j < 9){
                    if(a[i - 1][j + 1] == '#'){
                        cout << "NO";
                        return 0;
                    }
                }
                if(i > 0){
                    if(a[i - 1][j] == '#'){
                        unite(i * 10 + j, (i - 1) * 10 + j);
                    }
                }
                if(i < 9){
                    if(a[i + 1][j] == '#'){
                        unite((i + 1) * 10 + j, i * 10 + j);
                    }
                }
                if(j > 0){
                    if(a[i][j - 1] == '#'){
                        unite(i * 10 + j, i * 10 + j - 1);
                    }
                }
                if(j < 9){
                    if(a[i][j + 1] == '#'){
                        unite(i * 10 + j, i * 10 + j + 1);
                    }
                }

            }
        }
    }
    int cnt1 = 0, cnt2 = 0, cnt3 = 0, cnt4 = 0;
    for(int i = 0; i < 10; i++){
        for(int j = 0; j < 10; j++){
            if(a[i][j] == '#') {
                int idx = i * 10 + j;
                if (v[idx].size() == 1) {
                    cnt1++;
                }
                if (v[idx].size() == 2) {
                    cnt2++;
                }
                if (v[idx].size() == 3) {
                    cnt3++;
                }
                if (v[idx].size() == 4) {
                    cnt4++;
                }
                set<int> x, y;
                for (auto u: v[idx]) {
                    x.insert(kek[u].first);
                    y.insert(kek[u].second);
                }
                if (v[idx].size() == 3 || v[idx].size() == 4) {
                    if (x.size() == 1 || y.size() == 1) {
                        continue;
                    } else {
                        cout << "NO";
                        return 0;
                    }
                }
            }
        }
    }
    if(cnt1 == 4 && cnt2 == 3 && cnt3 == 2 && cnt4 == 1) {
        cout << "YES";
    }else{
        cout << "NO";
    }
}
