#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#define int long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define rbtree tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

// s.find_by_order(k) k - й по величине
// s.order_of_key(x) сколько меньше x

using namespace __gnu_pbds;
using namespace std;

int n;
vector<int> h, c;
vector<pair<int, int>> d;

void build(int v, int l, int r) {
    if (r - l == 1) {
        d[v] = {h[l], l};
    } else {
        int mid = (l + r) >> 1;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid, r);
        d[v] = max(d[v * 2 + 1], d[v * 2 + 2]);
    }
}

pair<int, int> get(int v, int tl, int tr, int l, int r) {
    if (l <= tl && tr <= r) {
        return d[v];
    }
    if (r <= tl || tr <= l) {
        return {-1, -1};
    }
    int mid = (tl + tr) >> 1;
    return max(get(v * 2 + 1, tl, mid, l, r), get(v * 2 + 2, mid, tr, l, r));
}

int rec(int l, int r) {
    if (l == r - 1) {
        return c[l];
    }
    int pos = get(0, 0, n, l, r).second;
    return c[pos] + min(rec(l, pos), rec(pos + 1, r));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    h.resize(n);
    c.resize(n);
    d.resize(4 * n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    build(0, 0, n);
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    cout << rec(0, n);
}
