import java.io.*;
import java.util.*;

public class Task2 {

    public static void main(String[] args) throws IOException {
        long n = nextLong(), m = nextLong();
        Map<Long, Long> map = new HashMap<>();

        for (int i = 0; i < m; i++) {
            long c = nextLong();

            if (map.containsKey(c)) map.replace(c, map.get(c) + 1);
            else map.put(c, 1L);
        }

        StringBuilder sb = new StringBuilder();
        int counter = 0;
        for (Map.Entry<Long, Long> entry: map.entrySet()) {
            if (entry.getValue() >= n) {
                sb.append(entry.getKey()).append(" ");
                counter++;
            }
        }

        System.out.println(counter);
        System.out.println(sb.substring(0, sb.length()-1));
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
