def check_around(x1, y1, x2, y2):
    for x in range(x1, x2 + 1):
        if field[y1][x] == '#':
            return False
    for x in range(x1, x2 + 1):
        if field[y2][x] == '#':
            return False
    for y in range(y1, y2 + 1):
        if field[y][x1] == '#':
            return False
    for y in range(y1, y2 + 1):
        if field[y][x2] == '#':
            return False
    return True


field = [["."] * 12]
checked = [[False] * 10 for i in range(10)]
for i in range(10):
    row = list("." + input() + ".")
    field.append(row)
field.append(["."] * 12)
success = True
sizes = [0, 4, 3, 2, 1]
for y in range(1, 11):
    for x in range(1, 11):
        if field[y][x] == '#':
            size = 1
            for_checking_start = [x - 1, y - 1]
            end_x = x
            end_y = y
            y_is_used = False
            x_is_used = False
            while field[end_y + 1][end_x] == '#':
                field[end_y + 1][end_x] = '.'
                size += 1
                end_y += 1
                y_is_used = True
            while field[end_y][end_x + 1] == '#':
                field[end_y][end_x + 1] = '.'
                size += 1
                end_x += 1
                x_is_used = True
            if y_is_used and x_is_used:
                success = False
                break
            if not check_around(*for_checking_start, end_x + 1, end_y + 1):
                success = False
                break
            sizes[size] -= 1

if any(sizes):
    success = False

print("YES" if success else "NO")
