#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int>> matrix;
vector<vector<bool>> used;

int dfs(int i, int j) {
    used[i][j] = true;
    vector<pair<int, int>> p = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
    int res = 1;
    for (auto [dx, dy] : p) {
        if (matrix[i + dx][j + dy] && !used[i + dx][j + dy]) {
            res += dfs(i + dx, j + dy);
        }
    }
    return res;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n>> m;
    map<int, int> a;
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        a[k]++;
    }

    vector<int> ans;
    for (auto [i, d] : a){
        if (d >= n)
            ans.push_back(i);
    }
    cout << ans.size() << '\n';
    for (const auto & elem : ans)
        cout << elem << ' ';


    return 0;
}
