#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int>> matrix;
vector<vector<bool>> used;

int dfs(int i, int j) {
    used[i][j] = true;
    vector<pair<int, int>> p = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};
    int res = 1;
    for (auto [dx, dy] : p) {
        if (matrix[i + dx][j + dy] && !used[i + dx][j + dy]) {
            res += dfs(i + dx, j + dy);
        }
    }
    return res;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    string s; cin >> s;
    string res;

    for (int i = (int)size(s)-1; i >= 0; i--){
        if (s[i] == '2'){
            res.push_back('5');
            continue;
        }else if (s[i] == '5'){
            res.push_back('2');
            continue;
        }else
            res.push_back(s[i]);
    }
    for (int i = 0; i < (int)size(res); i++){
        while (res[i] == '0'){
            i++;
        }
        cout << res[i] - '0';
    }

    return 0;
}
