#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

ld st(ld a, ll n) {
    if (!n)
        return 1;
    if (n == 1LL)
        return a;
    if (n & 1) {
        return st(a, n - 1) * a;
    }
    ld x = st(a, n / 2);
    return x * x;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;
    vector<pair<int, int>> days;
    for (int i = 0; i < n; i++) {
        int idx, w;
        cin >> idx >> w;
        days.emplace_back(idx, w);
    }
    sort(days.begin(), days.end());
    int prev = 0;
    ld cur = 0;
    map<int, ld> mp;
    for (auto [idx, w] : days) {
        cur = max((ld)0, cur * st(1 - r, idx - prev));
        prev = idx;
        cur += w * r;
        mp[idx] = cur;
    }
    while (m--) {
        int q;
        cin >> q;
        pair<int, ld> x;
        if (mp.rbegin()->first <= q) {
            x = *mp.rbegin();
        }
        else if (mp.begin()->first > q) {
            cout << 0 << ' ';
            continue;
        } else {
            auto it = mp.upper_bound(q);
            it--;
            x = *it;
        }
        cout << max((ld)0, x.second * st(1 - r, q - x.first)) << ' ';
    }
    return 0;
}
