#include <bits/stdc++.h>

#define ld long double
#define int long long
#define ll long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;

mt19937_64 rnd(100);


void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m, k, u, v;
    cin >> n >> m >> k;
    vector<set<ll>> g1(n), g2(n);
    vector<tuple<ll, ll, ll>> ans1, ans2;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        u--, v--;
        g1[u].insert(v);
        g1[v].insert(u);
    }
    for (int i = 0; i < k; ++i) {
        cin >> u >> v;
        u--, v--;
        g2[u].insert(v);
        g2[v].insert(u);
    }

    for (int i = 0; i < n; ++i) {
        if (g1[i].size() % 2 != g2[i].size() % 2) {
            cout << "NO";
            return;
        }
    }

    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        while (g1[i].size() > 1) {
            ll a = *g1[i].begin();
            g1[a].erase(i);
            g1[i].erase(g1[i].begin());
            ll b = *g1[i].begin();
            g1[b].erase(i);
            g1[i].erase(g1[i].begin());
            ans1.emplace_back(i + 1, a + 1, b + 1);
            if (g1[a].count(b)) {
                g1[a].erase(b);
                g1[b].erase(a);
            } else {
                g1[a].insert(b);
                g1[b].insert(a);
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        while (g2[i].size() > 1) {
            ll a = *g2[i].begin();
            g2[a].erase(i);
            g2[i].erase(g2[i].begin());
            ll b = *g2[i].begin();
            g2[b].erase(i);
            g2[i].erase(g2[i].begin());
            ans2.emplace_back(i + 1, a + 1, b + 1);
            if (g2[a].count(b)) {
                g2[a].erase(b);
                g2[b].erase(a);
            } else {
                g2[a].insert(b);
                g2[b].insert(a);
            }
        }
    }

    vector<ll> con1(n, -1), con2(n, -1);

    for (int i = 0; i < n; ++i) {
        if (!g1[i].empty())
            con1[i] = *g1[i].begin();
        if (!g2[i].empty())
            con2[i] = *g2[i].begin();
    }

    for (int i = 0; i < n; ++i) {
        if (con1[i] == -1)
            continue;
        if (con1[i] == con2[i])
            continue;

        ans1.emplace_back(i + 1, con1[i] + 1, con2[i] + 1);
        ans1.emplace_back(con1[i] + 1, con2[i] + 1, con1[con2[i]] + 1);
    }

    cout << ans1.size() + ans2.size() << '\n';
    for (auto &i: ans1)
        cout << get<0>(i) << ' ' << get<1>(i) << ' ' << get<2>(i) << '\n';


    while (!ans2.empty()) {
        cout << get<0>(ans2.back()) << ' ' << get<1>(ans2.back()) << ' ' << get<2>(ans2.back()) << '\n';
        ans2.pop_back();
    }
}

/*
3 0 3
1 2
2 3
3 1

4 3 3
1 2
2 3
3 4
1 3
4 2
2 3


*/

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
5 9
+
-1
+
+
+
+
-4
+
+
 */
