#include <bits/stdc++.h>

#define ld long double
#define int long long
#define ll long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;

mt19937_64 rnd(100);

struct segtree {
    int siz;
    vector<pair<int, int>> tree;

    inline void init(int n, vector<ll> &inp) {
        siz = 1;
        while (siz < n) {
            siz *= 2;
        }
        tree.resize(2 * siz);
        for (int i = 0; i < n; ++i)
            tree[i + siz] = {inp[i], i};
        ll siz0 = siz;
        while (--siz)
            tree[siz] = max(tree[siz * 2], tree[siz * 2 + 1]);
        siz = siz0;
    }

    inline pair<int, int> ma(int v, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l)return {0, -1};
        if (ql <= l && r <= qr)return tree[v];
        int mid = (l + r) / 2;
        return max(ma(2 * v, l, mid, ql, qr), ma(2 * v + 1, mid, r, ql, qr));
    }
};

vector<ll> arr, cost;
segtree st;

ll f(ll l, ll r) {
    if (l >= r)
        return 0;
    if (l + 1 == r)
        return cost[l];
    auto p = st.ma(1, 0, st.siz, l, r);
    return min(f(l, p.S), f(p.S + 1, r)) + cost[p.S];
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;
    arr.resize(n);
    cost.resize(n);
    for (ll &i: arr)
        cin >> i;
    for (ll &i: cost)
        cin >> i;
    st = *new segtree();
    st.init(n, arr);
    cout << f(0, n);
}

/*
3
3 10 7
2 5 2

*/

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........

##..#.....
.......##.
.#..#....#
.#........
.#........
..........
####...#..
.......#..
.......#..
##.......#
 */
