#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;
vector<vector<char>> a;
int n, m;

inline bool norm(vector<pair<int, int>> &x) {
    int cnt = 0;
    for (auto to: x)
        for (auto to1: x) {
            if (to == to1) {
                continue;
            }
            if ((to.first == to1.first && abs(to.second - to1.second) == 1) ||
                (to.second == to1.second && abs(to.first - to1.first) == 1))
                cnt++;
        }

    if (cnt < 6)
        return false;
    return true;
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<pair<int, int>> like = {{-1, -1},
                                   {-1, 0},
                                   {-1, 1},
                                   {0,  -1},
                                   {0,  1},
                                   {1,  -1},
                                   {1,  0},
                                   {1,  1}};

    map<vector<pair<int, int>>, int> s;
    queue<vector<pair<int, int>>> q;
    q.push({{0, 0},
            {0, 1},
            {1, 0},
            {1, 1}});
    s[q.front()] = 0;
    while (!q.empty()) {
        if (rand() % 1 == 0)continue;
        auto v = q.front();
        if (v == *new vector<pair<int, int>>{{n - 2, m - 2},
                                             {n - 2, m - 1},
                                             {n - 1, m - 2},
                                             {n - 1, m - 1}}) {
            cout << s[v];
            return;
        }
        q.pop();
        int o = 0;
        auto z = v;
        for (auto [i, j]: v) {
            for (auto to: like) {
                pair<int, int> w = {i + to.first, j + to.second};
                if (i + to.first < 0 || i + to.first >= n ||
                    j + to.second < 0 || j + to.second >= m || a[i + to.first][j + to.second] == '#' || w == v[0] ||
                    w == v[1] || w == v[2] || w == v[3])
                    continue;
                z[o].first += to.first;
                z[o].second += to.second;
                if (!norm(z)) {
                    z[o].first -= to.first;
                    z[o].second -= to.second;
                    continue;
                }
                stable_sort(z.begin(), z.end());
                if (!s.count(z)) {
                    s[z] = s[v] + 1;
                    q.push(z);
                }
                z = v;
            }
            o++;
        }
    }
    cout << -1;
}

/*

3 5
..###
.....
##...

2 2
..
..

2 6
......
......

2 6
......
..#...

 */
signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
