#include <bits/stdc++.h>

#define ld long double
#define int long long
#define ll long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;
mt19937_64 rnd(100);
vector<vector<char>> a;
int n, m;

bool norm(set<pair<int, int>> &x) {
    bool e = true;
    for (auto to: x) {
        if (to.first >= n || to.first < 0 || to.second >= m || to.second < 0) {
            e = false;
        }
    }
    int cnt = 0;
    if (x.size() != 4 || !e)return false;
    for (auto to: x) {
        if (a[to.first][to.second] == '#')return false;
        for (auto to1: x) {
            if (to == to1)continue;
            if ((to.first == to1.first && abs(to.second - to1.second) == 1) ||
                (to.second == to1.second && abs(to.first - to1.first) == 1))
                cnt++;
        }
    }
    if (cnt / 2 < 3)return false;
    return true;
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<pair<int, int>> like = {{-1, -1},
                                   {-1, 0},
                                   {-1, 1},
                                   {0,  -1},
                                   {0,  1},
                                   {1,  -1},
                                   {1,  0},
                                   {1,  1}};
    map<set<pair<int, int>>, int> s;
    queue<set<pair<int, int>>> q;
    q.push({{0, 0},
            {0, 1},
            {1, 0},
            {1, 1}});
    s[q.front()] = 0;
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto [i, j]: v) {
            for (auto to: like) {
                auto z = v;
                z.erase({i, j});
                z.insert({i + to.first, j + to.second});
                if (s.count(z))continue;
                if (norm(z)) {
                    s[z] = s[v] + 1;
                    q.push(z);
                }
            }
        }
    }
    if (!s.count({{n - 2, m - 2},
                  {n - 2, m - 1},
                  {n - 1, m - 2},
                  {n - 1, m - 1}})) {
        cout << -1;
    } else {
        cout << s[{{n - 2, m - 2},
                   {n - 2, m - 1},
                   {n - 1, m - 2},
                   {n - 1, m - 1}}];
    }
}

/*

3 5
..###
.....
##...

2 2
..
..

2 6
......
......

2 6
......
..#...

 */
signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
