#include <bits/stdc++.h>

using namespace std;
vector<vector<char>> a;
int n, m;


inline bool norm(set<pair<int, int>> &x) {
    int cnt = 0;
    for (auto &to: x) {
        for (auto &to1: x) {
            if (to == to1)continue;
            if ((to.first == to1.first && abs(to.second - to1.second) == 1) ||
                (to.second == to1.second && abs(to.first - to1.first) == 1))
                cnt++;
        }
    }
    if (cnt < 6)return false;
    return true;
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    vector<pair<int, int>> like = {{-1, -1},
                                   {-1, 0},
                                   {-1, 1},
                                   {0,  -1},
                                   {0,  1},
                                   {1,  -1},
                                   {1,  0},
                                   {1,  1}};
    map<set<pair<int, int>>, int> s;
    queue<set<pair<int, int>>> q;
    q.push({{0, 0},
            {0, 1},
            {1, 0},
            {1, 1}});
    s[q.front()] = 0;
    while (!q.empty()) {
        auto v = q.front();
        q.pop();
        for (auto &[i, j]: v) {
            for (auto &to: like) {
                if (v.count({i + to.first, j + to.second}) || i + to.first < 0 || i + to.second >= n ||
                    j + to.second < 0 || j + to.second >= m || a[i + to.first][j + to.second] == '#')
                    continue;
                auto z = v;
                z.erase({i, j});
                z.insert({i + to.first, j + to.second});
                if (s.count(z))continue;
                if (norm(z)) {
                    s[z] = s[v] + 1;
                    q.push(z);
                }
            }
        }
    }
    if (!s.count({{n - 2, m - 2},
                  {n - 2, m - 1},
                  {n - 1, m - 2},
                  {n - 1, m - 1}})) {
        cout << -1;
    } else {
        cout << s[{{n - 2, m - 2},
                   {n - 2, m - 1},
                   {n - 1, m - 2},
                   {n - 1, m - 1}}];
    }
}

/*

3 5
..###
.....
##...

2 2
..
..

2 6
......
......

2 6
......
..#...

 */
signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
