#include <bits/stdc++.h>

#define ld long double
#define int long long
#define ll long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;

mt19937_64 rnd(100);

ld po(ld x, int st) {
    if (st == 0)return 1;
    if (st == 1) {
        return x;
    }
    if (st % 2 == 0) {
        ld z = po(x, st / 2);
        return z * z;
    } else {
        ld z = po(x, st / 2);
        return z * z * x;
    }
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    set<pair<int, int>> z;
    z.insert({0, 0});
    for (int i = 0; i < n; ++i) {
        z.insert(a[i]);
    }
    ld x = 0;
    map<int, ld> ans;
    int last = 0;
    for (auto to: z) {
        x = x * po((ld) 1 - r, to.first - last) + (ld) r * to.second;
        ans[to.first] = x;
        last = to.first;
    }
    for (int i = 0; i < m; ++i) {
        int q;
        cin >> q;
        auto e = *(--z.upper_bound({q, LLONG_MAX}));
        int dist = q - e.first;
        cout << fixed << setprecision(15) << ans[e.first] * po(1 - r, dist) << " ";
    }
}

/*
 3 3
0.5
2 6
3 8
4 10
1 3 5

 5 6
0.3333333
1 27
6 27
3 27
4 27
5 27
1 2 3 4 5 6

 */
signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
