#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 2e9, mod = 1e9 + 7;

void solve() {
    vector<string> a(10);
    for (int i = 0; i < 10; ++i) cin >> a[i];

    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == '.') {
                continue;
            }

            if (j > 0 && i < 9 && a[i + 1][j - 1] == '#') {
                cout << "NO";
                return;
            }
            if (j < 9 && i < 9 && a[i + 1][j + 1] == '#') {
                cout << "NO";
                return;
            }

            if (j < 9 && a[i][j + 1] == '#' && i < 9 && a[i + 1][j] == '#') {
                cout << "NO";
                return;
            }
            if (j > 0 && a[i][j - 1] == '#' && i < 9 && a[i + 1][j] == '#') {
                cout << "NO";
                return;
            }
        }
    }

    vector<int> cnt(5, 0);
    for (int i = 0; i < 10; ++i) {
        int cnt1 = 0, cnt2 = 0;

        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == '#') {
                ++cnt1;
            } else if (cnt1 != 0) {
                cnt[cnt1]++;
                cnt1 = 0;
            }

            if (a[j][i] == '#') {
                ++cnt2;
            } else if (cnt2 != 0) {
                cnt[cnt2]++;
                cnt2 = 0;
            }
        }

        if (cnt1 != 0) {
            cnt[cnt1]++;
            cnt1 = 0;
        }

        if (cnt2 != 0) {
            cnt[cnt2]++;
            cnt2 = 0;
        }
    }

    cnt[1] = 0;

    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == '.') {
                continue;
            }

            bool flag = true;
            if (j > 0 && a[i][j - 1] == '#') {
                flag = false;
            }
            if (j < 9 && a[i][j + 1] == '#') {
                flag = false;
            }
            if (i > 0 && a[i - 1][j] == '#') {
                flag = false;
            }
            if (i < 9 && a[i + 1][j] == '#') {
                flag = false;
            }

            if (flag) {
                cnt[1]++;
            }
        }
    }

    if (cnt[1] == 4 && cnt[2] == 3 && cnt[3] == 2 && cnt[4] == 1) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}
/*
#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
.......
.......#.......
####...#..
.......#
##........

##..#.....
.......##.
.#..#....#
.#........
.#........
..........
####...#..
.......#..
.......#..
##.......#
 */