#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 2e9, mod = 1e9 + 7;

void solve() {
    int w, h, ans = 0;
    cin >> w >> h;

    ans = w * h;

    if (max(w, h) == 1) {
        cout << 1;
        return;
    }

    queue<pair<int, int>> q;
    q.emplace(w, h);

    map<pair<int, int>, int> dp;
    while (!q.empty()) {
        w = q.front().first;
        h = q.front().second;

        q.pop();

        if (h < w) {
            swap(h, w);
        }

        if (w == 1) {
            swap(h, w);
        }

        int w1 = 1, w2 = w - 1;

        dp[{w, h}] = w1 * h + w2 * h;
        ans += w1 * h + w2 * h;

        if (max(w1, h) > 1) {
            if (dp.find({w1, h}) != dp.end()) {
                ans += dp[{w1, h}];
                continue;
            }

            q.emplace(w1, h);
        }
        if (max(w2, h) > 1) {
            if (dp.find({w2, h}) != dp.end()) {
                ans += dp[{w2, h}];
                continue;
            }

            q.emplace(w2, h);
        }
    }

    cout << ans;
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}