#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

map<pair<int, int>, int> dp;

int rec(int w, int h) {
    if (min(w, h) == 0) {
        return 0;
    }

    if (w == h && w == 1) {
        return 1;
    }

    if (w > h) {
        swap(w, h);
    }

    if (dp.find({w, h}) != dp.end()) {
        return dp[{w, h}];
    }

    if ((w < h && h > 1) || h == 1) {
        dp[{w, h}] = rec(w - 1, h) + rec(1, h) + w * h;
    } else {
        dp[{w, h}] = rec(w, h - 1) + rec(w, 1) + w * h;
    }

    return dp[{w, h}];
}

void solve() {
    int w, h;
    cin >> w >> h;

    if (max(w, h) == 1) {
        cout << 1;
        return;
    }

    cout << rec(w, h);
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}