#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

map<int, int> mp;
map<int, deque<int>> ans;
set<int> s;

void print(int x) {
    if (ans[x].empty()) {
        cout << x << ' ';
        return;
    }

    print(ans[x].back());
    ans[x].pop_back();
    print(x);
}

void rec(int d) {
    if (d == 1) {
        print(*s.begin());
        return;
    }

    int x = 0;

    set<int> del;
    for (auto [temp, el] : mp) {
        if (el == 1) {
            x++;
            del.insert(temp);
        }
        mp[temp]--;
    }

    if (x > d / 2) {
        cout << -1;
        exit(0);
    }

    queue<int> q;
    for (auto el : s) {
        if (del.find(el) != del.end()) {
            ans[q.front()].push_back(el);
            q.pop();
        } else {
            q.push(el);
        }
    }

    for (auto el : del) {
        s.erase(el);
    }

    rec(d / 2);
}

void solve() {
    int n, x;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> x;
        mp[x]++;
        s.insert(x);
    }

    if (s.size() != n / 2 + 1) {
        cout << -1;
        exit(0);
    }

    rec(n / 2 + 1);
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}