#include <bits/stdc++.h>
#include <experimental/random>
#define ll long long
#define all(x) x.begin(), x.end()

using namespace std;

vector<int> c, h, tree;

void init(int l, int r, int n) {
    if (r - l == 1) {
        tree[n] = l;
        return;
    }

    int m = (l + r) / 2;
    init(l, m, 2 * n + 1);
    init(m, r, 2 * n + 2);

    if (h[tree[2 * n + 1]] > h[tree[2 * n + 2]]) {
        tree[n] = tree[2 * n + 1];
    } else {
        tree[n] = tree[2 * n + 2];
    }
}

int query(int l, int r, int n, int q_l, int q_r) {
    if (l >= q_r || r <= q_l) {
        return -1;
    }

    if (r - l == 1) {
        return l;
    }

    int m = (l + r) / 2, ans1 = query(l, m, 2 * n + 1, q_l, q_r), ans2 = query(m, r, 2 * n + 2, q_l, q_r);
    if (ans1 == -1) {
        return ans2;
    } else if (ans2 == -1) {
        return ans1;
    }
    if (h[ans1] > h[ans2]) {
        return ans1;
    }

    return ans2;
}

ll rec(int l, int r) {
    if (r - l == 1) {
        return c[l];
    }

    int m = query(0, c.size(), c.size(), l, r);

    if (l == m || r == m + 1) {
        return c[m];
    }

    return min(rec(l, m), rec(m + 1, r)) + c[m];
}

void solve() {
    int n;
    cin >> n;

    c.resize(n);
    h.resize(n);
    tree.resize(4 * n);

    init(0, n, 0);

    for (int i = 0; i < n; ++i) cin >> h[i];
    for (int i = 0; i < n; ++i) cin >> c[i];

    cout << rec(0, n);
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}