#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    solve();
    return 0;
}

#define int long long
#define endl '\n'
const int N=2e5+100,INF=2e18;
struct seg_tree{
    pair<int,int> t[4*N];
    void build(int v,int l,int r,vector<int>&a){
        if(l==r){
            t[v]={a[l],l};
            return;
        }
        int m=(l+r)/2;
        build(v*2,l,m,a);
        build(v*2+1,m+1,r,a);
        t[v]=max(t[v*2],t[v*2+1]);
    }
    pair<int,int> get(int v,int l,int r,int tl,int tr){
        if(l>=tl && r<=tr){
            return t[v];
        }
        if(l>tr || r<tl){
            return {-INF,-INF};
        }
        int m=(l+r)/2;
        return max(get(v*2,l,m,tl,tr),get(v*2+1,m+1,r,tl,tr));
    }
};
seg_tree t;
vector<int> h,c;
int n;
int ans(int l,int r){
    auto mx=t.get(1,0,n-1,l,r);
    if(l>r){
        return 0;
    }
    if(l==r){
        return c[l];
    }else{
        int p=mx.second;
        return c[p]+min(ans(l,p-1),ans(p+1,r));
    }
}
void solve() {
    cin>>n;
    h.resize(n);
    c.resize(n);
    for(int i=0;i<n;i++){
        cin>>h[i];
    }
    for(int i=0;i<n;i++){
        cin>>c[i];
    }
    t.build(1,0,n-1,h);
    cout<<ans(0,n-1)<<endl;
}