#include <bits/stdc++.h>

using namespace std;
#define ll long long
vector<vector<int>> used(12, vector<int>(12, -1));
ll cnt = 0;

void dfs(ll i, ll j, vector<vector<ll>> &g) {
    used[i][j] = 1;

    if (g[i - 1][j] == 1 && g[i][j + 1] == 1) {
        cout << "NO";
        exit(0);
    }
    if (g[i][j - 1] == 1 && g[i + 1][j] == 1) {
        cout << "NO";
        exit(0);
    }
    if (g[i - 1][j] == 1 && g[i][j - 1] == 1) {
        cout << "NO";
        exit(0);
    }
    if (g[i + 1][j] == 1 && g[i][j + 1] == 1) {
        cout << "NO";
        exit(0);
    }

    if (g[i + 1][j + 1] == 1 || g[i - 1][j - 1] == 1 || g[i - 1][j + 1] == 1 || g[i + 1][j - 1] == 1) {
        cout << "NO";
        exit(0);
    }
    if (used[i][j + 1] == 0) {
        cnt++;
        dfs(i, j + 1, g);
    } else {
        if (used[i + 1][j] == 0) {
            cnt++;
            dfs(i + 1, j, g);
        } else {
            cnt++;
            return;
        }
    }


}


signed main() {
    vector<vector<ll>> g(12, vector<ll>(12, -1));
    for (ll i = 1; i <= 10; ++i) {
        for (ll j = 1; j <= 10; ++j) {
            char x;
            cin >> x;
            if (x == '.') {
                used[i][j] = 1;
                g[i][j] = 0;
            } else {
                used[i][j] = 0;
                g[i][j] = 1;
            }

        }
    }
    vector<ll> test;
    for (ll i = 1; i <= 10; ++i) {
        for (ll j = 1; j <= 10; ++j) {
            if (used[i][j] == 0) {
                cnt = 0;
                dfs(i, j, g);
                test.push_back(cnt);
            }
        }
    }
    std::sort(test.begin(), test.end());
    vector<ll> res = {1, 1, 1, 1, 2, 2, 2, 3, 3, 4};
    if (res == test) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}