#include <bits/stdc++.h>

using namespace std;
#define ll long long
vector<ll> s;
vector<ll> z;
vector<pair<ll, ll>> tree;
ll n;
pair<ll, ll> mx(ll v, ll vl, ll vr, ll l, ll r) {
    if (l <= vl and r >= vr) {
        return tree[v];
    }
    ll mid = (vl + vr) / 2;
    if(vr<=l or r<=vl){
        return {-1,-1};
    }
    pair<ll, ll> v1 = mx(2 * v, vl, mid, l, r);
    pair<ll, ll> v2 = mx(2 * v + 1, mid, vr, l, r);
    if(v1.first>v2.first){
        return v1;
    }else{
        return v2;
    }
}

void build(ll v, ll vl, ll vr) {
    if (vr - vl == 1) {
        tree[v] = {s[vl], vl};
        return;
    }
    ll mid = (vl + vr) / 2;
    build(v * 2, vl, mid);
    build(v * 2 + 1, mid, vr);
    if ((tree[v * 2].first > tree[v * 2 + 1].first)) {
        tree[v] = {tree[v * 2].first, tree[v * 2].second};
    } else {
        tree[v] = {tree[v * 2 + 1].first, tree[v * 2 + 1].second};
    }

}

ll rec(ll l, ll r) {
    ll index=mx(1,0,n,l,r).second;
    if(index==l){
        return z[l];
    }
    if(index==r-1){
        return z[r-1];
    }
    return min(z[index]+rec(l,index),z[index]+rec(index+1,r));
}

signed main() {
    cin >> n;
    s.resize(n);
    z.resize(n);
    tree.resize(n*4);
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    build(1, 0, n);
    for (ll i = 0; i < n; i++) {
        cin >> z[i];
    }
    cout << rec(0, n);
}