﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <fstream>

using namespace std;
typedef long long ll;
map<int, int>posl;
int log2(int a) {
	int ans = 0;
	while (a != 1) {
		a /= 2;
		ans++;
	}
	return ans;
}
pair<vector<int>, vector<int>> split(vector<int> fath, int m) {
	vector<int> ans;
	for (int i = m ; i < fath.size(); i++) {
		ans.push_back(fath[i]);
	}
	for (int i = m ; i < fath.size(); i++) {
		fath.pop_back();
	}
	fath.pop_back();
	return{ fath, ans };
}
void gen(int k, vector<int> now) {
	if (now.size() == 2) {
		posl[now[0]] = posl[now[0]] + 2;
		posl[now[1]] = posl[now[1]] + 1;
		return;
	}

	pair<vector<int>, vector<int>> c = split(now, now.size() / 2);
	posl[c.first[0]] = posl[c.first[0]] + 1;
	gen(k, c.first);
	gen(k, c.second);

}
int main() {

	ios::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif


	int n; cin >> n;
	int k = log2(n + 1);
	map<int, int> mp;
	vector<int> uni;
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		uni.push_back(x);
		mp[x] = mp[x] + 1;
	}
	set<int> st;
	for (auto i : uni) {
		st.insert(i);
	}
	uni.clear();
	for (auto i : st) {
		uni.push_back(i);
	}
	gen(k,uni);
	int now = 0;
	for (auto i : uni) {
		if (posl[i] != mp[i]) {
			cout << -1; return 0;
		}
	}
	for (auto i : uni) {
		cout << i << " ";
	}

}
