﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <fstream>

using namespace std;
typedef long long ll;

int main() {

	ios::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	int n; cin >> n;
	vector<ll>h(n), c(n);
	for (int i = 0; i < n; i++) {
		cin >> h[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	ll r = 0, l = n, m, ans = 0;
	while (m != r || m != l) {
		m = 0;
		for (int i = r; i < l; i++) {
			if (h[i] > h[m]) {
				m = i;
			}
		}
		ans += c[m];
		if (m == r || m == l - 1) {
			cout << ans;
			return 0;
		}
		else if (m + 1 > n - 1 - m) {
			r = m + 1;
		}
		else {
			l = m;
		}
	}
}