﻿#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <fstream>

using namespace std;
typedef long long ll;
pair<vector<pair<int, int>>, vector<pair<int, int>>> split(vector<pair<int, int>> fath, int m) {
	vector<pair<int, int>> ans;
	for (int i = m + 1; i < fath.size(); i++) {
		ans.push_back(fath[i]);
	}
	for (int i = m + 1; i < fath.size(); i++) {
		fath.pop_back();
	}
	return{ fath, ans };
}
ll f(int n, vector <pair <int, int>> v)
{
	if (n == 0)
	{
		return 0;
	}
	if (n == 1)
	{
		return v[0].second;
	}
	int y = 0;
	for (int i = 0; i < n; i++)
	{
		if (v[i].first > v[y].first)
		{
			y = i;
		}
	}
	pair <vector <pair <int, int>>, vector <pair <int, int>>> c;
	c = split(v, y);
	return min(f(y, c.first) + v[y].second, f(n - y - 1, c.second) + v[y].second);
}
int main() {

	ios::sync_with_stdio(false);
	cin.tie(0);

#ifdef _DEBUG
	ifstream cin("input.txt");
	ofstream cout("output.txt");
#endif
	int n;
	cin >> n;
	vector <pair <int, int>> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].first;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> v[i].second;
	}
	cout << f(n, v);
}
