import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        ArrayList<Integer> a = new ArrayList<>(), b = new ArrayList<>();
        TreeMap<Integer, Integer> list = new TreeMap<>();
        for (int i = 0; i < n; ++i) {
            a.add(nextInt());
            list.put(a.get(i), i);
        }
        for (int i = 0; i < n; ++i) {
            b.add(nextInt());
        }
        while (!list.isEmpty()) {
            int x = list.firstKey();
            int y = list.get(x);
            list.pollFirstEntry();
            if (y > 0 && y < n - 1) {
                if (a.get(y - 1) < a.get(y) && a.get(y + 1) < a.get(y)) {
                    if (b.get(y - 1) > b.get(y + 1)) {
                        b.add(y, b.get(y) + b.get(y + 1));
                    } else {
                        b.add(y, b.get(y) + b.get(y - 1));
                    }
                    b.remove(y - 1);
                    b.remove(y);
                    b.remove(y);
                    a.remove(y - 1);
                    a.remove(y);
                } else if (a.get(y - 1) < a.get(y)) {
                    b.add(y, b.get(y) + b.get(y - 1));
                    b.remove(y - 1);
                    b.remove(y);
                    a.remove(y - 1);
                } else {
                    b.add(y, b.get(y) + b.get(y + 1));
                    b.remove(y + 1);
                    b.remove(y + 1);
                    a.remove(y + 1);
                }
            } else if (y > 0 && a.get(y - 1) < a.get(y)) {
                b.add(y, b.get(y) + b.get(y - 1));
                b.remove(y - 1);
                b.remove(y);
                a.remove(y - 1);
            } else if(y < n - 1 && a.get(y + 1) < a.get(y)) {
                b.add(y, b.get(y) + b.get(y + 1));
                b.remove(y + 1);
                b.remove(y + 1);
                a.remove(y + 1);
            }
        }
        long ans = 0;
        for (int i = 0; i < b.size(); ++i) {
            ans += b.get(i);
        }
        out.print(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}