#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;

const ll INF = 1e18, MAXN = 2e5;

random_device rd;
mt19937_64 rnd(rd());

void solve() {
    int n;
    cin >> n;
    map<int, int> cnt;
    set<int> cur;
    int c = 0, last = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cur.insert(x);
        cnt[x]++;
        c += (cnt[x] == 1);
        if (cnt[x] > cnt[last]) {
            last = x;
        }
    }
    n = (1LL << (int)(log2(n + 1) - 1));
    int n1 = n;
    vector<pair<int, int>> v;
    while (n > 1) {
        set<int> erased;
        for (auto &e : cnt) {
            e.second--;
            if (e.second == 0) {
                erased.insert(e.first);
            }
        }
        if ((int)erased.size() != n / 2) {
            cout << "-1";
            return;
        }
        for (auto &e : erased) {
            cnt.erase(e);
            cur.erase(e);
        }
        set<int> curs;
        for (auto &e : cur) {
            curs.insert(-e);
        }
        for (auto &e : erased) {
            auto k = curs.lower_bound(-e);
            if (k == curs.end()) {
                cout << "-1";
                return;
            }
            curs.erase(*k);
            v.emplace_back(-*k, e);
        }
        n /= 2;
    }
    map<int, vector<int>> g;
    for (auto &e : v) {
//        cout << e.first << ' ' << e.second << '\n';
        g[e.first].push_back(e.second);
    }
    vector<int> ans;
    map<int, bool> used;
    while ((int)(ans.size()) < n1) {
        bool ch = false;
        if (!used[last]) {
            ans.push_back(last);
            used[last] = true;
            ch = true;
        }
        for (auto &e : g[last]) {
            if (!used[e]) {
                used[e] = true;
                last = e;
                ans.push_back(e);
                ch = true;
            }
        }
        if (!ch) {
            cout << -1;
            return;
        }
    }
    for (int &e : ans) {
        cout << e << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
