#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

const ll INF = 1e18, MAXN = 2e5 + 10;

random_device rd;
mt19937_64 rnd(rd());

vector<int> g(4 * MAXN, -1);
vector<set<int>> cnt(MAXN);
int n;

void rec(int v, int d, int left = false, int mn = 1) {
    if (n == d || cnt[n - d].empty()) {
        return;
    }
    auto k = cnt[n - d].lower_bound(mn);
    if (k == cnt[n - d].end()) {
        cout << "-1";
        exit(0);
    }
//    cout << v << " " << *k << '\n';
    int mx = *k;
    cnt[n - d].erase(k);
    if (n - d - 1 >= 1) {
        cnt[n - d - 1].insert(mx);
    }
    g[v] = mx;
    g[2 * v + 1] = mx;
    rec(2 * v + 1, d + 1, true, mx);
    rec(2 * v + 2, d + 1, false,mx);
}

int get(int v, int i, int lq, int rq) {
    if (rq - lq == 1) {
        return g[v];
    }
    int m = (rq + lq) / 2;
    if (i < m) {
        return get(2 * v + 1, i, lq, m);
    }
    return get(2 * v + 2, i, m, rq);
}

void solve() {
    cin >> n;
    map<int, int> mp;
    set<int> cur;
    int c = 0, last = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        cur.insert(x);
        mp[x]++;
        c += (mp[x] == 1);
        if (mp[x] > mp[last]) {
            last = x;
        }
    }
    n = (int)(log2(n + 1) - 1);
    int n1 = n;
    int mx = 0;
    for (auto &e : mp) {
        if (e.second > 0) {
            cnt[e.second].insert(e.first);
        }
    }
    rec(0, -1);
    vector<int> ans(1LL << n);
    for (int i = 0; i < (1LL << n); i++) {
        ans[i] = get(0, i, 0, 1LL << n);
        if (ans[i] < 1) {
            cout << -1;
            return;
        }
    }
    for (int &e : ans) {
        cout << e << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
