﻿#include <iostream>
#include <map>
#include<set>
#include <vector>
#include <algorithm>

#include <iomanip>
#define int long long
using namespace std;

long double bpow(long double a, int b) {
	if (b == 0) return 1;
	if (b % 2 == 0) return bpow(a * a, b / 2);
	return a * bpow(a * a, b / 2);
}

signed main() {
	int n, m;
	cin >> n >> m;;
	long double r;
	cin >> r;
	r = 1 - r;
	vector<pair<int, int>> z(n);
	for (auto& i : z) cin >> i.first >> i.second;
	sort(z.begin(), z.end());
	vector<pair<int, int>> q(m);
	for (int i = 0; i < m; i++) {
		int a;
		cin >> a;
		q[i] = { a, i };
	}
	int  l = 0, d = 0;
	long double  ans = 0;
	vector<long double> v(m);
	sort(q.begin(), q.end());
	for (int i = 0; i < m; i++) {
		while (d < q[i].first) {
			if (l<z.size() && z[l].first <= q[i].first) {
				ans *= bpow(r, z[l].first - d);
				ans += z[l].second * (1 - r);
				//ans *= r;
				d = z[l].first;
				l++;
			}
			else {
				ans *= bpow(r, q[i].first - d);
				d = q[i].first;
			}
		}
		v[q[i].second] = ans;
	}
	for (auto& i : v) cout << setprecision(100) << i << ' ';
}

/*
5 6
0.333333
1 27
6 27
3 27
4 27
5 27
1 2 3 4 5 6
*/