#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define int ll
const int MAXN=300001;
vector<int> dist(MAXN, (int)1e9 * (int)1e9);
vector<pair<int, int>> g[MAXN];
int n,m;
int get(int i, int j) {
    return i*m+j;
}
void solve() {
    cin >> n >> m;
    char a[n][m];
    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            cin >> a[i][j];
        }
    }
    bool f[n][m];
    for(int i=0;i<n-1;i++) {
        for(int j=0;j<m-1;j++) {
            if(a[i][j]=='.' && a[i+1][j]=='.' && a[i][j+1]=='.' && a[i+1][j+1]=='.') {
                f[i][j]=true;
            }
            else {
                f[i][j]=false;
            }
        }
    }
    for(int i=0;i<n-1;i++) {
        for(int j=0;j<m-1;j++) {
            if(f[i][j]) {
                vector<int> x = {-1, 0, 1}, y = {-1, 0, 1};
                for(int aa : x){
                    for(int bb : y){
                        if(i + aa >= 0 && i + aa < n - 1 && j + bb >= 0 && j + bb < m - 1){
                            if(f[i + aa][j + bb])
                                g[get(i, j)].emplace_back(get(i + aa, j + bb), (abs(aa) + abs(bb) >= 2 ? 5 : 4));
                        }
                    }
                }
            }
        }
    }
    set<pair<int, int>> st;
    st.insert({0, get(0, 0)});
    dist[get(0, 0)] = 0;
    while(!st.empty()){
        int v = st.begin()->second;
        st.erase({dist[v], v});
        for(auto [u, w] : g[v]){
            if(dist[u] > dist[v] + w){
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                st.insert({dist[u], u});
            }
        }
    }
    if(dist[get(n - 2, m - 2)] == (int)1e9 * (int)1e9)
        cout << -1;
    else
        cout << dist[get(n - 2, m - 2)];
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
