#include <bits/stdc++.h>
#define ll long long
#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define ld long double
#define pii pair <int, int>
using namespace std;

const ll MOD = 1e9 + 7, INF = 1e18, N = 2e5 + 5;

mt19937 rnd(4321);

map <int, int> cnt;

vector <vector <int> > col(N);

vector <int> bb, tree(4 * N);

vector <int> ans;

void build(int l, int r, int h, int d, int val = 0) {
    if (l == r) {
        if (val) {
            tree[h] = val;
            bb.push_back(val);
            ans.push_back(val);
            return;
        }
        if (col[d].empty()) {
            cout << -1;
            exit(0);
            return;
        }
        tree[h] = col[d].back();
        bb.push_back(tree[h]);
        col[d].pop_back();
        ans.push_back(tree[h]);
        return;
    }
    if (val) {
        tree[h] = val;
    } else {
        if (col[d].empty()) {
            cout << -1;
            exit(0);
            return;
        }
        tree[h] = col[d].back();
        col[d].pop_back();
        val = tree[h];
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    build(l, m, h1, d - 1, val);
    build(m + 1, r, h2, d - 1);
    if (tree[h] != min(tree[h1], tree[h2])) {
        cout << -1;
        exit(0);
    }
    tree[h] = min(tree[h1], tree[h2]);
    bb.emplace_back(tree[h]);

}

void solve() {
    ll n, nn;
    cin >> n; nn = n + 1;
    int lg= 0;
    while(nn > 1) {
        lg++;
        nn /= 2;
    }
//    cout << lg << endl;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i]]++;
    }
//    if (n == 1) {
//        cout << -1;
//        return;
//    }
    for (auto [x, dx] : cnt) {
        col[dx].emplace_back(x);
        if (dx > lg) {
            cout << -1;
            return;
        }
    }
    for (int i = 1; i < n + 1; i++) {
        sort(col[i].rbegin(), col[i].rend());
    }
    build(1, (n + 1) / 2, 0, lg);
    sort(all(a));
    sort(all(bb));
    if (a != bb) {
        cout << -1;
        return;
    } else {
        for (auto & e : ans) {
            cout << e << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}
