#include <bits/stdc++.h>
#define ll long long
#define int long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
#define ld long double
#define pii pair <int, int>
using namespace std;

const ll MOD = 1e9 + 7, INF = 1e18, N = 2e5 + 5;

mt19937 rnd(4321);

vector <int> tree(4 * N, INF), f(4 * N);

void push(int h) {
    if (!f[h]) return;
    int h1 = 2 * h + 1, h2 = 2 * h + 2;
    if (!f[h1] || f[h1] > f[h]) {
        f[h1] = f[h];
        tree[h1] = min(f[h], tree[h1]);
    }
    if (!f[h2] || f[h2] > f[h]) {
        f[h2] = f[h];
        tree[h2] = min(f[h], tree[h2]);
    }
    f[h] = 0;
    return;
//    f[h1] = f[h2] = f[h];
}

void upd(int l, int r, int h, int tl, int tr, int x) {
    if (tl > tr) return;
    if (tl <= l && r <= tr) {
        if (!f[h] || f[h] > x) {
            f[h] = x;
            tree[h] = min(tree[h], x);
        }
//        if (tree[h] > x) {
//            tree[h] = x;
//            f[h] = x;
//        }
        return;
    }
    if (tr < l || r < tl) return;
    push(h);
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    upd(l, m, h1, tl, tr, x);
    upd(m + 1, r, h2, tl, tr, x);
    tree[h] = min(tree[h1], tree[h2]);
}

int get(int l, int r, int h, int tl, int tr) {
    if (tl <= l && r <= tr) {
        return tree[h];
    }
    if (tr < l || r < tl) {
        return 1e18;
    }
    push(h);
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    return min(get(l, m, h1, tl, tr), get(m + 1, r, h2, tl, tr));
}


void solve() {
    ll n;
    cin >> n;
    vector <int> h(n + 2), c(n + 1), lmax(n + 2), rmax(n + 2);
    for (int i = 1; i < n + 1; i++) {
        cin >> h[i];
    }
    for (int i = 1; i < n + 1; i++) {
        cin >> c[i];
    }
    upd(0, n, 0, 0, 0, 0);
    h[0] = 1e9 + 1;
    h[n + 1] = 1e9 + 1;
    vector <int> st;
    for (int i = n; i >= 0; i--) {
        while(!st.empty() && h[st.back()] < h[i]) {
            lmax[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    st.clear();
    for (int i = 1; i < n + 2; i++) {
        while(!st.empty() && h[st.back()] < h[i]) {
            rmax[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    for (int i = 1; i < n + 1; i++) {
        int j = lmax[i];
        int tmp = get(0, n, 0, j, i - 1) + c[i];
        int prv = get(0, n, 0, i - 1, i - 1) + c[i];
        upd(0, n, 0, i, i, tmp);
        upd(0, n, 0, i + 1, rmax[i] - 1, prv);
    }
    cout << get(0, n, 0, n, n);

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}
