#define miska ris

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

using ll = long long;
using ld = long double;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

#define val first
#define indx second
pair<int, int> d[int(8e5)];
ll h[200100], c[200100];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        d[v].val = h[l];
        d[v].indx = l;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return {0, 0};
    }
    if (ql <= l && r <= qr) {
        return d[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

ll n;

// l- левая граница обр. отрезка, r- правая
ll rec(ll l, ll r) {
    if (r < l)return 0;
    if (l == r)return c[l];
    ll mx = 0, mxi = l;
    mxi = get(0, 0, n, l, r + 1).second;
    ll left = 1e17;
    ll right = 1e17;
    right = rec(mxi + 1, r);
    left = rec(l, mxi - 1);
    return c[mxi] + min(left, right);
}

void solve() {
    ll i, j, k, m;
    cin >> n;
    for (i = 0; i < n; i++)cin >> h[i];
    for (i = 0; i < n; i++)cin >> c[i];
    build(0, 0, n);
    cout << rec(0, n - 1);
}