#include <bits/stdc++.h>

#define ll long long

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("popcnt,avx2,fma")
using namespace std;

void fastinout() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
}

ll x[200010], s[200010], h[200010], c[200010], n;

void build(ll v, ll l, ll r) {
    if (l == r) {
        s[v] = l;
        return;
    }
    ll m = l + (r - l) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    if (h[s[2 * v]] > h[s[2 * v + 1]]) {
        s[v] = s[2 * v];
    } else {
        s[v] = s[2 * v + 1];
    }
}

ll ans(ll v, ll l, ll r, ll l1, ll r1) {
    if (l >= l1 && r <= r1)return s[v];
    if (l > r1 || r < l1)return -1;
    int m = l + (r - l) / 2;
    int q = ans(2 * v, l, m, l1, r1);
    int w = ans(2 * v + 1, m + 1, r, l1, r1);
    if (q == -1)return w;
    else if (w == -1)return q;
    else {
        if (h[q] > h[w])return q;
        else return w;
    }
}

ll rec(int l, int r) {
    if (l > r) {
        return 0;
    }
    int q = ans(1, 0, n - 1, l, r);
    return c[q] + min(rec(l, q - 1), rec(q + 1, r));
}


signed main() {
    fastinout();
    int i, j;
    cin >> n;
    for (i = 0; i < n; i++)cin >> h[i];
    for (i = 0; i < n; i++)cin >> c[i];
    build(1, 0, n - 1);
    cout << rec(0, n - 1);
    return 0;
}
