#include <iostream>
#include <bits/stdc++.h>
using namespace std;
#define ld long double


ld bp(ld x, int s) {
    if (s == 1) {
        return x;
    }
    if (s % 2 == 0) {
        ld a = bp(x, s / 2);
        return a * a;
    }
    return x * bp(x, s - 1);
}


int main() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> v(n + 1);
    v[0] = {0, 0};
    ld r;
    cin >> r;
    for (int i = 1; i <= n; ++i) {
        int d, w;
        cin >> d >> w;
        v[i].first = d;
        v[i].second = w;
    }
    std::sort(v.begin(), v.end());
    vector<pair<int, ld>> pref(n + 1, {0, 0});
    for (int i = 1; i <= n; ++i) {
        int st = v[i].first - v[i - 1].first;
        pref[i].first = v[i].first;
        pref[i].second = pref[i - 1].second * bp((1 - r), st) + r * v[i].second;
    }
    cout << fixed << setprecision(100);
    while (m--) {
        int k;
        cin >> k;
        int a = 0, b = n + 1;
        while (a != b - 1) {
            int sr = (a + b) / 2;
            if (pref[sr].first <= k) {
                a = sr;
            } else {
                b = sr;
            }
        }
        if (k == pref[a].first) {
            cout << pref[a].second << " ";
        } else {
            cout << pref[a].second * bp((1 - r), k - pref[a].first) << " ";
        }
    }
    return 0;
}
