#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define rbtree tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

// s.find_by_order(k) k - й по величине
// s.order_of_key(x) сколько меньше x

using namespace __gnu_pbds;
using namespace std;


int bin_pow(int n, int k) {
    if (k == 0) {
        return 1;
    }
    if (k % 2 == 0) {
        int t = bin_pow(n, k / 2);
        return t * t;
    } else {
        return n * bin_pow(n, k - 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    map<int, int> m;
    int k = 0;
    while (pow(2, k) - 1 != n) {
        k++;
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        m[x]++;
    }
    map<int, vector<int>> s;
    vector<int> used(k, 0);
    vector<int> otv;
    for (auto i: m) {
        s[i.second].push_back(i.first);
    }
    for (int i = 0; i <= k; i++) {
        int l = 0, r = k;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (i % bin_pow(2, mid) == 0) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (s[l + 1].size() <= used[l]) {
            cout << -1;
            return 0;
        }
        otv.push_back(s[l + 1][used[l]]);
        used[l]++;
    }
    for (auto i: otv) {
        cout << i << ' ';
    }
}
