#include <bits/stdc++.h>

using namespace std;

long long n;
vector<long long> h, c;
vector<pair<long long, long long>> d;

void build(long long v, long long l, long long r) {
    if (r - l == 1) {
        d[v] = {h[l], l};
    } else {
        long long mid = (l + r) >> 1;
        build(v * 2 + 1, l, mid);
        build(v * 2 + 2, mid, r);
        d[v] = max(d[v * 2 + 1], d[v * 2 + 2]);
    }
}

pair<long long, long long> get(long long v, long long tl, long long tr, long long l, long long r) {
    if (l <= tl && tr <= r) {
        return d[v];
    }
    if (tr <= l || r <= tl) {
        return {-1, -1};
    }
    long long mid = (tl + tr) >> 1;
    return max(get(v * 2 + 1, tl, mid, l, r), get(v * 2 + 2, mid, tr, l, r));
}

long long rec(long long l, long long r) {
    if (l == r) {
        return 0;
    }
    if (l == r - 1) {
        return c[l];
    }
    long long pos = 0;
    pair<long long, long long> getx = get(0, 0, n, l, r);
    pos = getx.second;
    if (pos == l) {
        return c[l];
    }
    if (pos == r - 1) {
        return c[r - 1];
    }
    return c[pos] + min(rec(l, pos), rec(pos + 1, r));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    h.resize(n);
    c.resize(n);
    d.resize(4 * n);
    for (long long i = 0; i < n; i++) {
        cin >> h[i];
    }
    for (long long i = 0; i < n; i++) {
        cin >> c[i];
    }
    build(0, 0, n);
    cout << rec(0, n);
}