#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define rbtree tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

// s.find_by_order(k) k - й по величине
// s.order_of_key(x) сколько меньше x

using namespace __gnu_pbds;
using namespace std;

struct event{
    int x, type, idx;

    bool operator<(const event &other){
        return (x < other.x || (x == other.x && type < other.type));
    }
};

ld bin_pow(ld n, int k){
    if(k == 0){
        return 1.0;
    }
    if(k % 2 == 0){
        ld t = bin_pow(n, k / 2);
        return t * t;
    }else{
        return n * bin_pow(n, k - 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
    int n, m;
    cin >> n >> m;
    ld r;
    cin >> r;
    vector<int> d(n), q(m), w(n);
    vector<event> v;
    for(int i = 0; i < n; i++){
        cin >> d[i] >> w[i];
        v.push_back({d[i], 1, i});
    }
    for(int i = 0; i < m; i++){
        cin >> q[i];
        v.push_back({q[i], 2, i});
    }
    sort(v.begin(), v.end());
    vector<ld> ans(m);
    ld prev_val = 0;
    int prev_x = 0;
    for(auto u : v){
        if(u.type == 1){
            ld val = prev_val * bin_pow(1 - r, u.x - prev_x) + r * w[u.idx];
            prev_val = val;
            prev_x = u.x;
        }else{
            ld val = prev_val * bin_pow(1 - r, u.x - prev_x);
            ans[u.idx] = val;
            prev_val = val;
            prev_x = u.x;
        }
    }
    for(auto u: ans){
        cout << u << ' ';
    }
}
