import java.io.*;
import java.util.*;

public class TaskC {

    public static void main(String[] args) throws IOException {
        long h = nextLong(), w = nextLong();
        System.out.println(solve(h, w));
    }

    private static long solve(long h, long w) {
        if (h == 1 && w == 1) return 1;

        if (h == 1) {
            return h * w + solve(h, w / 2) + solve(h, w - w / 2);
        }

        return h * w + solve(h / 2, w) + solve(h - h / 2, w);
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}