import java.io.*;
import java.util.*;

public class TaskF {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        ArrayList<Integer> arrayList = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            arrayList.add(nextInt());
        }

        Set<Integer> set = new HashSet<>(arrayList);
        int min = arrayList.get(0);
        int max = arrayList.get(0);

        for (int i = 0; i < arrayList.size(); i++) {
            if (Collections.frequency(arrayList, arrayList.get(i)) < min) {
                min = Collections.frequency(arrayList, arrayList.get(i));
            }
            if (Collections.frequency(arrayList, arrayList.get(i)) > max) {
                max = Collections.frequency(arrayList, arrayList.get(i));
            }
        }
        if (set.size() == 1) {
            System.out.println("-1");
        }
        else if (max > min) {
            List<Integer> list = new ArrayList<>(set);

            for (int i = 0; i < list.size(); i++) {
                System.out.printf("%s ", list.get(i));
            }
        } else {
            System.out.println("-1");
        }
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}