import java.io.*;
import java.util.*;

public class TaskI {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        ArrayList<Integer> array1 = new ArrayList<>();
        ArrayList<Integer> array2 = new ArrayList<>();
        Map<Integer, Integer> map = new LinkedHashMap<>();

        for (int i = 0; i < n; i++) {
            array1.add(nextInt());
        }

        for (int i = 0; i < n; i++) {
            array2.add(nextInt());
        }

        Collections.sort(array1);

        int min = Integer.MAX_VALUE;

        for (int i = 0; i < n; i++) {
            if (array1.get(i) < min) {
                min = array1.get(i);
            }
            map.put(array1.get(i), array2.get(i));
        }


        int counter = 0;

        if (map.size() == 1) {
            for (Map.Entry<Integer, Integer> entry: map.entrySet()) {
                counter += entry.getValue();
            }
        }

        for (Map.Entry<Integer, Integer> entry: map.entrySet()) {
            if (entry.getKey() != min) counter += entry.getValue();
        }

        System.out.println(counter);

    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}