#include <bits/stdc++.h>
#define int long long
typedef long long ll;
/*#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#define time_start clock_t start = clock()
#define time_stop clock_t stop = clock(); double elapsed = (double) (stop-start) / CLOCKS_PER_SEC; printf("\nTime elapsed : %.5f\n", elapsed)
*/
using namespace std;
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
const int N = 2*1e5;
int logs[N+1];
unordered_map<int, int> idof;
vector<vector<int>> spmx;
vector<vector<int>> build_sparce(const vector<int>& arr){
    int n  = arr.size();
    int maxpow = ceil(log2(n+1));
    vector<vector<int>> sparce(maxpow, vector<int> (n, 0));
    sparce[0]=arr;
    for (int i = 0; i+1 < maxpow; ++i) {
        for (int j = 0; j+(1<<i) < n; ++j) {
            sparce[i+1][j]=max(sparce[i][j], sparce[i][j+(1<<i)]);
        }
    }
    return sparce;
}
int getmx(int l, int r){
    int power = logs[r-l];
    return max(spmx[power][l], spmx[power][r-(1<<power)]);
}
vector<int> h, c;
ll rec(int l, int r){
    if(r==l)
        return c[l];
    else if(r<l)
        return 0;
    int id = idof[getmx(l, r+1)];
    ll ans = c[id];
    ans += min(rec(l, id-1), rec(id+1, r));
    return ans;
}
int32_t main() {
    int n; cin >> n;
    h.resize(n);
    c.resize(n);
    logs[1]=0;
    for (int i = 2; i < N+1; ++i) {
        logs[i] = logs[i>>1]+1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
        idof[h[i]]=i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    spmx = build_sparce(h);
    cout << rec(0, n-1);
}
/*
 11
 8 2 10 3 5 7 11 1 6 4 9
 3 3 2 5 6 1 7 3 4 4 10

 2
1 2
3 3
 */
