#include <bits/stdc++.h>

#define ld long double
#define int long long
#define ll long long
#define F first
#define S second
using namespace std;
const int mod = 1e9 + 7;

mt19937_64 rnd(100);
vector<vector<int>> g;
vector<bool> used;
int sz;

void dfs(int v) {
    used[v] = true;
    sz++;
    for (int to: g[v]) {
        if (used[to])continue;
        dfs(to);
    }
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    vector<vector<char>> a(10, vector<char>(10));
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            cin >> a[i][j];
        }
    }
    bool e = true;
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == '.')continue;
            if (i + 1 < 10 && j + 1 < 10) {
                e &= (a[i + 1][j + 1] == '.');
            }
            if (i + 1 < 10 && j - 1 >= 0) {
                e &= (a[i + 1][j - 1] == '.');
            }
            if (i - 1 >= 0 && j - 1 >= 0) {
                e &= (a[i - 1][j - 1] == '.');
            }
            if (i - 1 >= 0 && j + 1 < 10) {
                e &= (a[i - 1][j + 1] == '.');
            }
        }
    }
    if (!e) {
        cout << "NO";
        return;
    }
    g.resize(100);
    for (int i = 0; i < 10; ++i) {
        for (int j = 0; j < 10; ++j) {
            if (a[i][j] == '.')continue;
            if (i + 1 < 10 && a[i + 1][j] == '#') {
                g[i * 10 + j].push_back((i + 1) * 10 + j);
            }
            if (j + 1 < 10 && a[i][j + 1] == '#') {
                g[i * 10 + j].push_back(i * 10 + j + 1);
            }
            if (i - 1 >= 0 && a[i - 1][j] == '#') {
                g[i * 10 + j].push_back((i - 1) * 10 + j);
            }
            if (j - 1 >= 0 && a[i][j - 1] == '#') {
                g[i * 10 + j].push_back(i * 10 + j - 1);
            }
        }
    }
    used.assign(100, false);
    vector<int> cnt(100, 0);
    for (int i = 0; i < 100; ++i) {
        if (a[i / 10][i % 10] == '.')continue;
        if (!used[i]) {
            sz = 0;
            dfs(i);
            cnt[sz - 1]++;
        }
    }
    for (int i = 4; i < 100; ++i) {
        e &= (cnt[i] == 0);
    }
    e &= (cnt[0] == 4);
    e &= (cnt[1] == 3);
    e &= (cnt[2] == 2);
    e &= (cnt[3] == 1);
    if (e) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
/*
#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........

##..#.....
.......##.
.#..#....#
.#........
.#........
..........
####...#..
.......#..
.......#..
##.......#
 */
