#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
using namespace std;
int n, q, k, maxn;
vector<int> p;
vector<vector<int>> tr;

int maxpow2(int x) {
    int y = 1;
    while (y < x) {
        y *= 2;
    }
    return y;
}

vector<int> vs;

inline void getv(int v, int lv, int rv, int r) {
    if (rv <= r) {
        vs.push_back(v);
        return;
    }
    if (lv >= r) {
        return;
    }
    int mid = (lv + rv) / 2;
    getv(v * 2, lv, mid, r);
    getv(v * 2 + 1, mid, rv, r);
}

void solve() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q >> k;
    k--;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        p[i]--;
    }
    vector<int> idxs(n);
    for (int i = 0; i < n; ++i) {
        idxs[p[i]] = i;
    }
    vector<pair<int, int>> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].F >> qs[i].S;
        qs[i].F--;
    }
    reverse(qs.begin(), qs.end());
    maxn = maxpow2(n);
    tr.resize(maxn * 2);
    for (int i = 0; i < n; ++i) {
        tr[i + maxn] = {p[i]};
    }
    for (int i = maxn - 1; i >= 1; --i) {
        tr[i].resize(tr[i * 2].size() + tr[i * 2 + 1].size());
        merge(tr[i * 2].begin(), tr[i * 2].end(), tr[i * 2 + 1].begin(), tr[i * 2 + 1].end(), tr[i].begin());
    }
    for (int i = 0; i < q; ++i) {
        if (k < qs[i].F || k >= qs[i].S) {
            continue;
        }
        int o = k - qs[i].F;
        vs.clear();
        getv(1, 0, maxn, qs[i].S-qs[i].F);
        int l = 0, r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            int cnt = 0;
            for (int j: vs) {
                cnt += (lower_bound(tr[j].begin(), tr[j].end(), mid) - tr[j].begin());
            }
            if (cnt <= o) {
                l = mid;
            } else {
                r = mid;
            }
        }
        k = qs[i].F + idxs[l];
    }
    cout << k+1;
}

/*
8 6 3
 1 5 2 8 7 4 3 6
 1 8
 2 4
 7 8
 1 1
 1 3
 2 7

 */
signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
    }
    return 0;
}
