#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int inf = 2e9, mod = 1e9 + 7;

vector<int> qx = {1, 0, 0, -1};
vector<int> qy = {0, -1, 1, 0};

void solve() {
    vector<vector<char>> v(12, vector<char> (12, '.'));
    for (int i = 1; i <= 10; i++) {
        for (int j = 1; j <= 10; j++) {
            cin >> v[i][j];
        }
    }
    map<int, int> mp;
    int n = 10;
    for (int i = 1; i <= n; i++) {
        int l = 1, r = 1;
        while (r <= n) {
            if (v[i][r] == '#') {
                r++;
            } else {
                if (r - l != 1) mp[r - l]++;
                l = r;
                for (; l <= n; l++) {
                    if (v[i][l] == '#') {
                        break;
                    }
                }
                r = l;
            }
        }
    }
    for (int j = 1; j <= n; j++) {
        int l = 1, r = 1;
        while (r <= n) {
            if (v[r][j] == '#') {
                r++;
            } else {
                if (r - l != 1) mp[r - l]++;
                l = r;
                for (; l <= n; l++) {
                    if (v[l][j] == '#') {
                        break;
                    }
                }
                r = l;
            }
        }
    }
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= n; j++) {
            int f = 1;
            if (v[i][j] != '#') {
                continue;
            }
            if (v[i + 1][j] == '#') f = 0;
            if (v[i][j + 1] == '#') f = 0;
            if (v[i - 1][j] == '#') f = 0;
            if (v[i][j - 1] == '#') f = 0;
            if (f) {
                mp[1]++;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (v[i][j] != '#') continue;
            if (v[i + 1][j + 1] == '#') {
                cout << "NO";
                return;
            }
            if (v[i - 1][j - 1] == '#') {
                cout << "NO";
                return;
            }
            if (v[i - 1][j + 1] == '#') {
                cout << "NO";
                return;
            }
            if (v[i + 1][j - 1] == '#') {
                cout << "NO";
                return;
            }
        }
    }
    if (mp[1] == 4 && mp[2] == 3 && mp[3] == 2 && mp[4] == 1) cout << "YES";
    else cout << "NO";
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}
/*
#.#.#.....
.......##.
.#..#.....
.#........
.#..##....
..........
####...#..
.......#..
.......#..
##........

##..#.....
.......##.
.#..#....#
.#........
.#........
..........
####...#..
.......#..
.......#..
##.......#
 */