#include <bits/stdc++.h>
#define int long long
#define all(x) x.begin(), x.end()
#define double long double
using namespace std;

double pw(double c, int sp) {
    if (sp == 0) return 1;
    if (sp == 1) {
        return c;
    }
    if (sp % 2 == 1) {
        return pw(c, sp - 1) * c;
    }
    else {
        return pw(c * c, sp / 2);
    }
}

void solve() {
    int n, m, x, y;
    cin >> n >> m;

    double r;
    cin >> r;

    vector<pair<int, double>> a;
    map<int, double> mp;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a.emplace_back(x, y * r);
    }

    sort(a.begin(), a.end());

    mp[a[0].first] = a[0].second;

    for (int i = 1; i < n; ++i) {
        a[i].second += a[i - 1].second * pw(1 - r, a[i].first - a[i - 1].first);
        mp[a[i].first] = a[i].second;
    }

    for (int i = 0; i < m; ++i) {
        cin >> x;

        auto it = mp.upper_bound(x);

        if (it == mp.begin()) {
            cout << "0 ";
            continue;
        }

        --it;
        int d = it->first;
        cout << fixed << setprecision(6) << mp[d] * pw(1 - r, x - d) << ' ';
    }
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}