#include <bits/stdc++.h>
#include <experimental/random>
#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

int k;
vector<int> c, h, h_sq;

int rec(int l, int r) {
    if (r - l == 1) {
        return c[l];
    }

    int i = l, m = l;
    for (; i < r;) {
        if (i % k == 0 && i + k < r) {
            if (h[m] < h[h_sq[i / k]]) {
                m = h_sq[i];
            }
            i += k;
        } else {
            if (h[m] < h[i]) {
                m = i;
            }
            ++i;
        }
    }

    if (l == m || r == m + 1) {
        return c[m];
    }

    return min(rec(l, m), rec(m + 1, r)) + c[m];
}

void solve() {
    int n;
    cin >> n;

    k = (int)sqrt(n);

    c.resize(n), h.resize(n), h_sq.resize(n / k);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];

        if (h[h_sq[i / k]] < h[i]) {
            h_sq[i / k] = i;
        }
    }

    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }

    cout << rec(0, n);
}

signed main() {
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}