#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    solve();
    return 0;
}

#define int long long
#define endl '\n'
const int N=100,INF=2e18;
int n=10,m=10;
void coloring(int i,int j,int c,vector<vector<int>> &resv){
    resv[i][j]=c;
    resv[i-1][j]=c;
    resv[i+1][j]=c;
    resv[i][j-1]=c;
    resv[i-1][j-1]=c;
    resv[i+1][j-1]=c;
    resv[i][j+1]=c;
    resv[i-1][j+1]=c;
    resv[i+1][j+1]=c;
}
bool diag(int i,int j,vector<vector<int>> &a){
    if(a[i][j]==1){
        if(a[i-1][j-1]==1)return false;
        if(a[i+1][j-1]==1)return false;
        if(a[i-1][j+1]==1)return false;
        if(a[i+1][j+1]==1)return false;
    }
    return true;
}
void solve(){
    vector<vector<int>> a(N,vector<int>(N,0));
    vector<vector<int>> used(N,vector<int>(N,0));
    vector<vector<int>> resv(N,vector<int>(N,0));
    for(int i=1;i<=n;i++){
        string s;
        cin>>s;
        for(int j=0;j<m;j++){
            if(s[j]=='#'){
                a[i][j+1]=1;
            }
        }
    }
    map<int,int> mp;
    int color=1;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++) {
            if(!diag(i,j,a)){
                cout<<"NO"<<endl;
                return;
            }
            if(a[i][j]==1 && resv[i][j] && !used[i][j]){
                cout<<"NO"<<endl;
                return;
            }
            if (a[i][j] == 1 && !used[i][j]) {
                int cnti=0,pi=i,cntj=0,pj=j;
                coloring(i,j,color,resv);
                while(pi<=n && a[pi][j]){
                    cnti++;
                    if(resv[pi][j]!=color && resv[pi][j]!=0){
                        cout<<"NO"<<endl;
                        return;
                    }
                    used[pi][j]=color;
                    coloring(pi,j,color,resv);
                    pi++;
                }
                while(pj<=m && a[i][pj]){
                    cntj++;
                    if(resv[i][pj]!=color && resv[i][pj]!=0){
                        cout<<"NO"<<endl;
                        return;
                    }
                    used[i][pj]=color;
                    coloring(i,pj,color,resv);
                    pj++;
                }
                if((cnti>1 && cntj>1) || cnti>4 || cntj>4){
                    cout<<"NO"<<endl;
                    return;
                }
                if(cnti==1 && cntj==1){
                    mp[1]++;
                }else if(cnti>1){
                    mp[cnti]++;
                }else{
                    mp[cntj]++;
                }
                color++;
            }
        }
    }
    if(mp[1]==4 && mp[2]==3 && mp[3]==2 && mp[4]==1){
        cout<<"YES"<<endl;
    }else{
        cout<<"NO"<<endl;
    }
}